# This is the "top level" derivation for an ownerboot build
{ nixpkgsOnBuildForHost
, nixpkgsOnBuildForBuild
, lib
, image
, scripts
}:

let
  writeShellScript = name: text:
    (nixpkgsOnBuildForHost.writeShellScript name text)
      .overrideAttrs(previousAttrs: {
        preferLocalBuild = true;
      });

in nixpkgsOnBuildForHost.stdenv.mkDerivation (finalAttrs: {
  name = "ownerboot";
  dontUnpack = true;
  dontBuild = true;
  installPhase = ''
    runHook preInstall

    mkdir -p $out/{etc,bin}
    ln -s ${image}/coreboot.rom  $out/
    ln -s ${image}/config        $out/etc/coreboot.config
    ln -s ${image.passthru.fmap} $out/etc/coreboot.fmap

  '' + (lib.concatStringsSep "\n" (lib.mapAttrsToList (scriptName: scriptText: ''
    ln -s ${writeShellScript scriptName scriptText} $out/bin/${scriptName}.sh

  '') scripts)) + ''
    runHook postInstall
  '';
})
